config/routes.rb
if ENV['RAILS_RELATIVE_URL_ROOT']
  Rails.application.routes.default_scope = ENV['RAILS_RELATIVE_URL_ROOT']
end

Rails.application.routes.draw do
  get 'up', to: ->(env) { [204, {}, ['']] }

  # ------------------------------------------------------------ Authentication
  # Sign in / sign out
  get '/login'  => 'sessions#new'
  get '/logout' => 'sessions#destroy'
  resource :session

  resources :comments

  # ------------------------------------------------------------ Project routes
  concern :multiple_destroy do
    collection do
      delete :multiple_destroy
    end
  end

  concern :multiple_update do
    collection do
      patch :multiple_update
    end
  end

  concern :previewable do
    member do
      post :preview
    end
  end

  resources :notifications, only: [:index, :update]

  resources :projects, only: [:index, :show] do
    resources :activities, only: [:index] do
      collection do
        get :poll, constraints: { format: /js/ }
      end
    end

    resources :boards do
      resources :lists, except: [:index] do
        member { post :move }
        resources :cards, except: [:index] do
          member { post :move }
          resources :revisions, only: [:index, :show]
        end
      end
    end

    constraints id: %r{[(0-z)\/]+} do
      resources :configurations, only: [:index, :update]
    end

    post :create_multiple_evidence, to: 'issues/evidence#create_multiple'

    resources :issues, concerns: [:multiple_destroy, :previewable] do
      collection do
        post :import
        resources :merge, only: [:new, :create], controller: 'issues/merge'
      end

      resources :evidence, concerns: :multiple_destroy, controller: 'issues/evidence', only: [:index, :new]
      resources :nodes, only: [:show], controller: 'issues/nodes'
      resources :revisions, only: [:index, :show]
    end

    resources :methodologies do
      collection { post :preview }
      member do
        get :add
        put :update_task
      end
    end

    resources :nodes do
      collection do
        post :sort
        post :create_multiple
      end

      member do
        get :tree
      end

      resource :merge, only: [:create], controller: 'nodes/merge'

      resources :notes, concerns: [:multiple_destroy, :previewable] do
        resources :revisions, only: [:index, :show]
      end

      resources :evidence, except: :index, concerns: [:multiple_destroy, :previewable] do
        resources :revisions, only: [:index, :show]
      end

      constraints(filename: /.*/) do
        resources :attachments, only: [:index, :show, :create, :destroy], param: :filename
      end
    end

    resources :notifications, only: [:index, :update]

    resources :revisions, only: [] do
      member { post :recover }
    end

    resources :tags, except: [:show] do
      collection { post :sort }
    end

    namespace :qa do
      resources :issues, only: [:edit, :index, :show, :update], concerns: [:multiple_update, :previewable]
    end

    get 'search' => 'search#index'
    get 'trash' => 'revisions#trash'

    # ------------------------------------------------------- Export Manager
    get  '/export' => 'export#index', as: :export_manager

    # ------------------------------------------------------- Upload Manager
    get  '/upload'        => 'upload#index',  as: :upload_manager
    post '/upload'        => 'upload#create'
    post '/upload/parse'  => 'upload#parse'

    if Rails.env.development?
      get '/styles' => 'styles_tylium#index'
    end
  end

  resources :console, only: [] do
    collection { get :status }
  end

  resource :fields, only: [] do
    collection do
      get :field
      post :form
      post :source
    end
  end

  namespace :setup, only: [:index] do
    if defined?(Dradis::Pro)
    else
      resource :password, only: [:new, :create]
    end
    resource :kit, only: [:new, :create]
  end

  resources :subscriptions, only: [:index, :create, :destroy]

  # -------------------------------------------------------------- Static pages
  resource :markup, controller: :markup, only: [] do
    get :help
    post :preview
  end

  if defined?(Dradis::Pro)
  else
    root to: 'setup/passwords#new'
  end

  mount ActionCable.server => '/cable'
end

app/models/tag.rb
# This is the main Tag class. We can tag a number of models including:
#   * Issues
#
# Some tag names have a special meaning:
#   * If they start with # they are used  to categorise / group things (e.g #infrastructure)
#   * If they start with @ they are meant to ‘assign ownership’ of the model (e.g. @daniel)
#   * If they start with ! they define their own colour (e.g. !red needs to be coloured red, !4444dd should be a dark shade of blue).
#     - We require a 6-digit hex code (no 3-digit shortcut)
class Tag < ApplicationRecord
  DEFAULT_TAGS = %w[
    !9467bd_critical
    !d62728_high
    !ff7f0e_medium
    !6baed6_low
    !2ca02c_info
  ].freeze

  acts_as_list

  # -- Relationships ----------------------------------------------------------
  has_many :taggings, dependent: :destroy

  def project
    # dummy project; this makes Tags's interface more similar to how it is
    # in Pro and makes it easier to deal with tag in URL helpers
    @project ||= Project.new
  end

  def project=(new_project); end

  # -- Callbacks --------------------------------------------------------------
  before_save :normalize_name

  # -- Validations ------------------------------------------------------------
  validates :name,
  presence: true,
  uniqueness: { case_sensitive: false } ,
  format: {
    with: /\A(!\h{6})_[a-zA-Z]+?\z/, message: 'is invalid: Numbers and special characters are not permitted.'
  }

  # -- Scopes -----------------------------------------------------------------
  default_scope { order(:position, :id) }

  # -- Class Methods ----------------------------------------------------------

  # -- Instance Methods -------------------------------------------------------

  # Returns a version of the tag's name suitable to present to the user:
  #  * If the tag name contains color details, they are stripped
  #  * The result is titleized
  def display_name()
    if self.name =~ /\A!(\h{6})(_([[:word:]]+))?\z/
      if $3
        out = $3
      else
        out = $1
      end
    else
      out = self.name
    end
    return out.titleize
  end

  # Strips the tag's name and returns the color details if present
  # if no color information is found, returns a default value of #ccc
  def color()
    name[/\A(!\h{6})_[[:word:]]+?\z/, 1].try(:gsub, '!', '#') || '#555'
  end

  private
  def normalize_name
    self[:name] = self.name.downcase
  end
end

app/controllers/tags_controller.rb
class TagsController < AuthenticatedController
  include ProjectScoped
  include ActivityTracking
  include Sortable

  before_action :set_columns, only: :index
  load_and_authorize_resource

  def index
    @tags = current_project.tags
  end

  def new; end

  def create
    @tag.project = current_project
    if @tag.save
      track_created(@tag)
      redirect_to request.referer, notice: 'Tag created.'
    else
      redirect_to request.referer, alert: @tag.errors.full_messages.join('; ')
    end
  end

  def edit; end

  def update
    if @tag.update(tag_params)
      track_updated(@tag)
      redirect_to project_tags_path(current_project), notice: 'Tag updated.'
    else
      redirect_to project_tags_path(current_project), alert: @tag.errors.full_messages.join('; ')
    end
  end

  def destroy
    if @tag.destroy
      track_destroyed(@tag)
      redirect_to project_tags_path(current_project), notice: 'Tag deleted.'
    else
      redirect_to project_tags_path(current_project), alert: @tag.errors.full_messages.join('; ')
    end
  end

  private

  def sortable_records
    { klass: Tag, ids: current_project.tags.ids }
  end

  def tag_params
    modified_params = params.require(:tag).permit(:name, :color)
    modified_params[:name] = "#{modified_params[:color].gsub('#', '!')}_#{modified_params[:name]}"
    modified_params.except(:color)
  end

  def set_columns
    default_field_names = ['Sort', 'Name'].freeze
    extra_field_names = ['Color', 'Created', 'Updated'].freeze

    @default_columns = default_field_names
    @all_columns = default_field_names | extra_field_names
  end
end

app/views/tags/_form.html.erb
<div class="modal-header">
  <h5 class="modal-title" id="modal-board-header"><%= header %></h5>
  <button type="button" class="btn-close" data-bs-dismiss="modal" aria-hidden="true">
    <span class="visually-hidden">Close modal</span>
  </button>
</div>
<%= form_for @tag, url: url, method: method do |f| %>
  <div class="modal-body">
    <div class="row">
      <div class="col-10">
        <div class="mb-3">
          <%= f.label :name, class: 'form-label' do %>
            Name <span class="required-input">*</span>
          <% end %>
          <%= f.text_field :name, value: @tag.new_record? ? '' : @tag.display_name, required: true, class: 'form-control' %>
          <span class="small text-muted mt-1">A-Z only. No special characters or numbers.</span>
        </div>
      </div>
      <div class="col-2">
        <div class="mb-3">
          <%= f.label :color, class: 'form-label d-block' do %>
            Color <span class="required-input">*</span>
          <% end %>
          <%= f.color_field :color, value: @tag.new_record? ? '' : @tag.color, required: true, class: 'form-control color-picker' %>
        </div>
      </div>
    </div>
  </div>
  <div class="modal-footer">
    <%= f.submit class: 'btn btn-primary' %>
    <button class="btn" type="button" data-bs-dismiss="modal" aria-hidden="true">Close</button>
  </div>
<% end %>

app/views/tags/_table.html.erb
<% cache ['tags-table', @all_columns, @tags] do %>
  <table class="table table-striped mb-0"
    data-behavior="dradis-datatable"
    data-default-columns="<%= @default_columns.to_json %>"
    data-item-name="tags"
    data-local-storage-key="project.ce.<%= dom_id(current_project) %>.tags_datatable">
    <thead>
      <tr>
        <% @all_columns.each do |column| %>
          <th class="no-sort" data-column-visible="<%= column != 'Sort' %>">
            <span class="<%= class_names('visually-hidden': column == 'Sort'  )%>"><%= column %></span>
          </th>
        <% end %>
        <th class="no-sort" data-column-visible="false"><span class="visually-hidden">Actions</span></th>
      </tr>
    </thead>
    <tbody data-behavior='ui-sortable', data-sort-url="<%= sort_project_tags_path(current_project) %>">
      <% @tags.each do |tag| %>
        <% cache [tag, @all_columns, 'tags-table'] do %>
          <tr id="tag-<%= tag.id %>">
            <% @all_columns.each do |column| %>
              <%
               content =
              case column
              when 'Sort'
                  content_tag(:i, nil, class: 'fa-solid fa-grip-vertical w-100') + content_tag(:span, 'Change sort order', class: 'visually-hidden')
              when 'Name'
                  content_tag(:span, class: 'tag', style: "color: #{tag.color}") do
                    content_tag(:i, nil, class: 'fa-solid fa-tag fa-fw me-1') + tag.display_name
                  end
              when 'Color'
                content_tag(:span, tag.color, style:  "color: #{tag.color}")
              when 'Created'
                local_time_ago(tag.created_at)
              when 'Updated'
                local_time_ago(tag.updated_at)
              end
              %>
              <%= content_tag :td, content, class: class_names('text-secondary text-center': column == 'Sort') %>
            <% end  %>
            <td class="column-actions">
              <%= link_to edit_project_tag_path(current_project, tag), remote: true do %>
                <i class="fa-solid fa-pencil"></i> Edit
              <% end %>
              <%= link_to project_tag_path(current_project, tag), method: :delete, data: { confirm: "Are you sure?\n\nProceeding will delete this tag. Any issues with this tag will be untagged." }, class: 'text-error-hover' do %>
                <i class="fa-solid fa-trash"></i> Delete
              <% end %>
            </td>
          </tr>
        <% end %>
      <% end %>
    </tbody>
  </table>
<% end %>

app/views/tags/edit.js.erb
$('[data-behavior~=modal-tag-form]').modal('show');
$('[data-behavior~=modal-tag-content]').html("<%= j (render partial: 'form', locals: { header: 'Edit tag', url: project_tag_path(current_project, @tag),  method: :patch }) %>");

app/views/tags/index.html.erb
<% content_for :title, 'Tags' %>
<div class="content-container mt-3">
  <h4 class="header-underline">Tags Management
    <span class="actions pt-1">
      <div class="action">
        <%= link_to new_project_tag_path(current_project), remote: :true do %>
          <i class="fa-solid fa-plus fa-fw"></i> New Tag
        <% end %>
      </div>
    </span>
  </h4>

  <% if @tags.any? %>
    <%= render 'table' %>
  <% else %>
    <div class="empty-state mt-3">
      <div class="empty-state-icon">
        <%= image_tag "icons/#{rand(9)}.svg" %>
      </div>
      <div class="empty-state-body">
        <div class="container">
          <h4 class="empty-state-title">There are no tags created yet.</h4>
          <p class="empty-state-body-text">Use tags to flag and/or organize your issues.</p>
          <div class="empty-state-actions">
            <a href="https://dradis.com/support/guides/projects/tags.html"
            class="empty-state-docs-link" target="_blank">More about tags</a>
          </div>
        </div>
      </div>
    </div>
  <% end %>
</div>

app/views/tags/new.js.erb
$('[data-behavior~=modal-tag-form]').modal('show');
$('[data-behavior~=modal-tag-content]').html("<%= j (render partial: 'form', locals: { header: 'Add new tag', url: project_tags_path(current_project),  method: :post }) %>");